<template>
<st-content :heading="titulo">
  <div>
    <v-row no-gutters>
      <v-col md="12">
        <st-student-data
          :studentName="this.sesion.alumno.nombre"
          :studentCode="this.sesion.alumno.codigo"
          :studentMail="this.sesion.alumno.correo"
          :studentCareer="this.sesion.alumno.unidad.nombre"
          :studentID="this.sesion.alumno.idAlumno"
          :nameTutorship="this.sesion.datos.nombreTutoria"
          :idTutorship="this.sesion.datos.idTutoria"
          color="content-body"
          
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col md="12">
        <st-session-data
          :sessionName="sesion.datos.nombreTutoria"
          :sessionDate="sesion.datos.fechaInicio"
          :sessionState="sesion.datos.idEstado"
          color="content-body"
          :historical = "historical2"
          :atendido = "atendido"
          @cancel = "Cancelar"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col md="12">
        <st-session-result
          :valueCom="sesion.datos.comentario"
          :valueDer="sesion.datos.idUnidadDerivada"
          :planDeAccion="sesion.planDeAccion"
          ref="sessionResult"
          color="content-body"
          :historical = "historical"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col class="text-right">
        <st-primary-btn :nombre="nombre" :loading="loadSave" @click="saveChanges" />
      </v-col>
    </v-row>
  </div>
</st-content>
</template>

<script>
import StudentData from "@/components/tutor/StudentData";
import SessionData from "@/components/tutor/SessionData";
import SessionResult from "@/components/tutor/SessionResult";

export default {
  data() {
    return {
      nombre: "SESIÓN ATENDIDA",
      titulo: "Cargando...",
      loadSave: false,
      switch1: true,
      text: " tareas pendientes",
      show: true,
      aux: {},
      historical: true,
      historical2 : true,
      atendido: false,
      sesion : {
           alumno: {
                idAlumno: '',//"d9be5677-3791-4fa4-beda-4ff36ef19d62",
                nombre: 'Cargando...',//"Juan Alberto Quezada Ruiz",
                codigo: 'Cargando...',//"19993256",
                correo:'Cargando...',// "juan.quezada@pucp.edu.pe",
                unidad: {
                    idUnidad: '',//"73d40eb8-cbb8-4650-8e69-01c30c083b32",
                    nombre: 'Cargando...',//"Ingenier\u00eda Inform\u00e1tica"
                }
            },
            datos: {
                idSession: '',//"259f96d2-8ffc-45e3-bacc-be2484853ce3",
                nombreTutoria: 'Cargando...',//"Tutor\u00eda de Momento",
                numeroOrden: '0',//1,
                fechaInicio: null,//"2020-07-10T14:20:00+00:00",
                comentario: '',//null,
                idUnidadDerivada: null,//null,
                idEstado: 'Cargando...',//"Pendiente"
            },
            "planDeAccion": []
      },
    };
  },
  components: {
    "st-student-data": StudentData,
    "st-session-data": SessionData,
    "st-session-result": SessionResult
  },
  methods: {
    async ini() {
      try {
       let { data: {data:{sesion}} } = await this.$api.getSession(this.$route.params.id)    
       this.sesion =JSON.parse(JSON.stringify(sesion))//sesion
        this.titulo =  "Sesión " +
        this.sesion.datos.numeroOrden.toString() +
        " de " +
        this.sesion.datos.nombreTutoria;
        if(this.sesion.datos.idEstado === "Atendido"){
           this.nombre =  "Actualizar"
           this.historical2 = false
           this.atendido = true
        }
      } catch (e) {
        this.$store.commit('setError', e)
      }
    },
    saveChanges() {
      this.loadSave = true;
      this.aux = this.$refs.sessionResult.imprimir();
       let data = {     
          "sesion":{
             // "fechaInicio": this.sesion.datos.fechaInicio, //Opcional
             // "fechaFin":new Date().toISOString().substr(0,19) + "-05:00",// "2020-07-10T15:00:00Z", //Opcional
              "comentario" : this.aux.comentario,//"El alumno requiere soporte con algunos cursos", //Opcional
              "derivación": true,//Opcional
              "idUnidadDerivada": this.aux.derivacion,//"id-id-id-id", //Opcional
              "idEstado": "Atendido"
            },
            "planDeAccion":  this.aux.planDeAccion
      }
      this.$api.updateSession(this.$route.params.id, data)
      .then( ({ data }) => {
        this.$router.go(-1)//this.$router.push('/tutor/tutorias')
      })
      .catch(( e ) => {
        this.$store.commit('setError', e)
      })
   // this.$router.push('/tutor/tutorias');
    },
    now(){
      let fecha = dia.toISOString()
      let hh = parseInt(fecha.substr(11,2))
      if(hh < 5) dia.setDate(dia.getDate() - 1);
      hh = (hh - 5 + 24)%24
      let aux = dia.toISOString().substr(0,11) + hh.toString(10) + dia.toISOString().substr(13,11)
      this.hora = aux
    },
    async Cancelar(){
     // this.loadSave = true;
      this.aux = this.$refs.sessionResult.imprimir();
       let data = {     
          "sesion":{
              "fechaInicio": this.sesion.datos.fechaInicio, //Opcional
             // "fechaFin":new Date().toISOString().substr(0,19) + "-05:00",// "2020-07-10T15:00:00Z", //Opcional
              "comentario" : this.aux.comentario,//"El alumno requiere soporte con algunos cursos", //Opcional
              "derivación": true,//Opcional
              "idUnidadDerivada": this.aux.derivacion,//"id-id-id-id", //Opcional
              "idEstado": "Cancelado"
            },
            "planDeAccion": this.aux.planDeAccion
      }
      this.$api.updateSession(this.$route.params.id, data)
      .then( ({ data }) => {
        this.$router.go(-1)//this.$router.push('/tutor/tutorias')
      })
      .catch(( e ) => {
        this.$store.commit('setError', e)
      })
    }
  },
  mounted() {
    this.ini();
  }
};
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
